%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# Projects depends on kubernetes
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         kubernetes
%global repo            heapster
# https://github.com/kubernetes/heapster
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     k8s.io/heapster
%global commit          0e1b652781812dee2c51c75180fc590223e0b9c6
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0.16.1
Release:        3%{?dist}
Summary:        Compute Resource Usage Analysis and Monitoring of Container Clusters 
License:        ASL 2.0
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

Patch0:         update-import-path.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
BuildRequires: golang(google.golang.org/cloud/compute/metadata)
BuildRequires: golang(github.com/coreos/fleet/client)
BuildRequires: golang(github.com/coreos/fleet/etcd)
BuildRequires: golang(github.com/coreos/fleet/machine)
BuildRequires: golang(github.com/coreos/fleet/pkg)
BuildRequires: golang(github.com/coreos/fleet/registry)
BuildRequires: golang(github.com/coreos/fleet/schema)
BuildRequires: golang(github.com/emicklei/go-restful)
BuildRequires: golang(github.com/golang/glog)
BuildRequires: golang(github.com/google/cadvisor/client)
BuildRequires: golang(github.com/google/cadvisor/info/v1)
BuildRequires: golang(github.com/google/gofuzz)
BuildRequires: golang(github.com/hawkular/hawkular-client-go/metrics)
BuildRequires: golang(github.com/influxdb/influxdb/client)
BuildRequires: golang(github.com/stretchr/testify/assert)
BuildRequires: golang(github.com/stretchr/testify/require)
BuildRequires: golang(k8s.io/kubernetes/pkg/api)
BuildRequires: golang(k8s.io/kubernetes/pkg/api/errors)
BuildRequires: golang(k8s.io/kubernetes/pkg/api/latest)
BuildRequires: golang(k8s.io/kubernetes/pkg/api/testapi)
BuildRequires: golang(k8s.io/kubernetes/pkg/api/v1)
BuildRequires: golang(k8s.io/kubernetes/pkg/client)
BuildRequires: golang(k8s.io/kubernetes/pkg/client/cache)
BuildRequires: golang(k8s.io/kubernetes/pkg/client/clientcmd)
BuildRequires: golang(k8s.io/kubernetes/pkg/client/clientcmd/api)
BuildRequires: golang(k8s.io/kubernetes/pkg/controller/framework)
BuildRequires: golang(k8s.io/kubernetes/pkg/fields)
BuildRequires: golang(k8s.io/kubernetes/pkg/labels)
BuildRequires: golang(k8s.io/kubernetes/pkg/runtime)
BuildRequires: golang(k8s.io/kubernetes/pkg/util)
BuildRequires: golang(k8s.io/kubernetes/pkg/watch)
%endif

Requires:      golang(google.golang.org/cloud/compute/metadata)
Requires:      golang(github.com/coreos/fleet/client)
Requires:      golang(github.com/coreos/fleet/etcd)
Requires:      golang(github.com/coreos/fleet/machine)
Requires:      golang(github.com/coreos/fleet/pkg)
Requires:      golang(github.com/coreos/fleet/registry)
Requires:      golang(github.com/coreos/fleet/schema)
Requires:      golang(github.com/emicklei/go-restful)
Requires:      golang(github.com/golang/glog)
Requires:      golang(github.com/google/cadvisor/client)
Requires:      golang(github.com/google/cadvisor/info/v1)
Requires:      golang(github.com/google/gofuzz)
Requires:      golang(github.com/hawkular/hawkular-client-go/metrics)
Requires:      golang(github.com/influxdb/influxdb/client)
Requires:      golang(github.com/stretchr/testify/assert)
Requires:      golang(github.com/stretchr/testify/require)
#Requires:      golang(k8s.io/kubernetes/pkg/api)
#Requires:      golang(k8s.io/kubernetes/pkg/api/errors)
#Requires:      golang(k8s.io/kubernetes/pkg/api/latest)
#Requires:      golang(k8s.io/kubernetes/pkg/api/testapi)
#Requires:      golang(k8s.io/kubernetes/pkg/api/v1)
#Requires:      golang(k8s.io/kubernetes/pkg/client)
#Requires:      golang(k8s.io/kubernetes/pkg/client/cache)
#Requires:      golang(k8s.io/kubernetes/pkg/client/clientcmd)
#Requires:      golang(k8s.io/kubernetes/pkg/client/clientcmd/api)
#Requires:      golang(k8s.io/kubernetes/pkg/controller/framework)
#Requires:      golang(k8s.io/kubernetes/pkg/fields)
#Requires:      golang(k8s.io/kubernetes/pkg/labels)
#Requires:      golang(k8s.io/kubernetes/pkg/runtime)
#Requires:      golang(k8s.io/kubernetes/pkg/util)
#Requires:      golang(k8s.io/kubernetes/pkg/watch)

Provides:      golang(%{import_path}/api/v1) = %{version}-%{release}
Provides:      golang(%{import_path}/api/v1/types) = %{version}-%{release}
Provides:      golang(%{import_path}/extpoints) = %{version}-%{release}
Provides:      golang(%{import_path}/integration) = %{version}-%{release}
Provides:      golang(%{import_path}/manager) = %{version}-%{release}
Provides:      golang(%{import_path}/model) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/api) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/cache) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/gcl) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/gcm) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/gcmautoscaling) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/hawkular) = %{version}-%{release}
Provides:      golang(%{import_path}/sinks/influxdb) = %{version}-%{release}
Provides:      golang(%{import_path}/sources) = %{version}-%{release}
Provides:      golang(%{import_path}/sources/api) = %{version}-%{release}
Provides:      golang(%{import_path}/sources/datasource) = %{version}-%{release}
Provides:      golang(%{import_path}/sources/nodes) = %{version}-%{release}
Provides:      golang(%{import_path}/store) = %{version}-%{release}
Provides:      golang(%{import_path}/store/daystore) = %{version}-%{release}
Provides:      golang(%{import_path}/store/statstore) = %{version}-%{release}
Provides:      golang(%{import_path}/third_party/window) = %{version}-%{release}
Provides:      golang(%{import_path}/util) = %{version}-%{release}
Provides:      golang(%{import_path}/util/gce) = %{version}-%{release}
Provides:      golang(%{import_path}/util/gcstore) = %{version}-%{release}
Provides:      golang(%{import_path}/validate) = %{version}-%{release}
Provides:      golang(%{import_path}/version) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}
%patch0 -p1

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go" | grep -v "./Godeps") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go" | grep -v "./Godeps"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}/integration
%gotest %{import_path}/manager
%gotest %{import_path}/model
%gotest %{import_path}/sinks
%gotest %{import_path}/sinks/api
%gotest %{import_path}/sinks/cache
%gotest %{import_path}/sinks/gcl
%gotest %{import_path}/sinks/hawkular
%gotest %{import_path}/sinks/influxdb
%gotest %{import_path}/sources
%gotest %{import_path}/sources/datasource
%gotest %{import_path}/sources/nodes
%gotest %{import_path}/store
%gotest %{import_path}/store/daystore
%gotest %{import_path}/store/statstore
%gotest %{import_path}/util/gcstore
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE
%doc RELEASES.md README.md CONTRIBUTING.md
%dir %{gopath}/src/k8s.io
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test -f unit-test.file-list
%license LICENSE
%doc RELEASES.md README.md CONTRIBUTING.md
%endif

%changelog
* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.16.1-3
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.16.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct 08 2015 jchaloup <jchaloup@redhat.com> - 0-0.1.git0e1b652
- First package for Fedora
  resolves: #1270005


